package ru.landgrafhomyak.serdha.api.v0.runtime

import ru.landgrafhomyak.serdha.api.v0.misc.Column

public interface Row<QueryUserExtension : Any> {
	public operator fun <RuntimeType> get(c: Column<RuntimeType, *, QueryUserExtension>): RuntimeType

	public operator fun get(c: Column<Byte, *, QueryUserExtension>): Byte = this.get<Byte>(c)
	public operator fun get(c: Column<UByte, *, QueryUserExtension>): UByte = this.get<UByte>(c)
	public operator fun get(c: Column<Short, *, QueryUserExtension>): Short = this.get<Short>(c)
	public operator fun get(c: Column<UShort, *, QueryUserExtension>): UShort = this.get<UShort>(c)
	public operator fun get(c: Column<Int, *, QueryUserExtension>): Int = this.get<Int>(c)
	public operator fun get(c: Column<UInt, *, QueryUserExtension>): UInt = this.get<UInt>(c)
	public operator fun get(c: Column<Long, *, QueryUserExtension>): Long = this.get<Long>(c)
	public operator fun get(c: Column<ULong, *, QueryUserExtension>): ULong = this.get<ULong>(c)
	public operator fun get(c: Column<Char, *, QueryUserExtension>): Char = this.get<Char>(c)
	public operator fun get(c: Column<Boolean, *, QueryUserExtension>): Boolean = this.get<Boolean>(c)
}